#define OPTIMIZE_ROM_CALLS
#define SAVE_SCREEN
#include <tigcclib.h>

short _ti89,_ti92plus;

int key, answer;

void MainDialog(void);
void Ask(void);
void NoSave(void);
void Save(void);
void GetKey(void);

void _main(void)
	{
	MainDialog();
	Ask();
	clrscr();
	if(answer == 1)
		Save();
	else if(answer == 0)
		NoSave();
	ngetchx();
	}

void MainDialog(void)
	{
	char buffer[1];
	int dialogkey;	
	HANDLE dialog;
	while(TRUE)
		{
		while(TRUE)
			{
			*buffer = 0;
			if(!(dialog = DialogNewSimple(154, 81)))
				return;
			DialogAddTitle(dialog, "Key Press v1.1", BT_OK, BT_CANCEL);
			DialogAddText(dialog, 2, 13, " This simple program will display the value");
			DialogAddText(dialog, 2, 19, "of any key pressed. Simply press a key and");
			DialogAddText(dialog, 2, 25, "it will return a value to the screen. Press");
			DialogAddText(dialog, 2, 31, "the [ON] key or the [ESC] key at any time to");
			DialogAddText(dialog, 2, 37, "exit the program.");
			DialogAddText(dialog, 2, 49, "Created by: Patel, Ronak.");
			DialogAddText(dialog, 2, 55, "Copyright  2000-2003");
			DialogAddText(dialog, 2, 61, "E-mail Ronakbhai@hotmail.com.");
			dialogkey = DialogDo(dialog, CENTER, CENTER, buffer, NULL);
			HeapFree(dialog);
			if(dialogkey == 13)
				return;
			else if(dialogkey == 264)
				exit(0);
			}
		}
	}

void Ask(void)
	{
	char buffer[1];
	int dialogkey;	
	HANDLE dialog;
	while(TRUE)
		{
		while(TRUE)
			{
			*buffer = 0;
			if(!(dialog = DialogNewSimple(141, 63)))
				return;
			DialogAddTitle(dialog, "Store to External File?", BT_OK, BT_CANCEL);
			DialogAddText(dialog, 2, 13, "Would you like to store the key presses");
			DialogAddText(dialog, 2, 19, "to an external file called \"keys\"?");
			DialogAddText(dialog, 2, 25, "The file will be viewable with the text");
			DialogAddText(dialog, 2, 31, "editor. WARNING! If a variable with the");
			DialogAddText(dialog, 2, 37, "name of \"keys\" already exists, then it");
			DialogAddText(dialog, 2, 43, "will be overwritten.");
			dialogkey = DialogDo(dialog, CENTER, CENTER, buffer, NULL);
			HeapFree(dialog);
			if(dialogkey == 13)
				{
				answer = 1;
				return;
				}
			else if(dialogkey == 264)
				{
				answer = 0;
				return;
				}
			}
		}
	}

void NoSave(void)
	{
	printf("KEY PRESS VALUE :");
	do
		{
		GetKey();
		}while((key != 264) && (key != 267));
	}

void Save(void)
	{
	FILE *f_out;
	f_out = fopen("keys", "w+t");
	fprintf(f_out, "Keys Pressed\n");
	printf("KEY PRESS VALUE :");
	do
		{
		GetKey();
		fprintf(f_out, "\n%d", key);
		}while((key != 264) && (key != 267));
	if(key == 264)
		fprintf(f_out, " - [ESC]");
	else if(key == 267)
		fprintf(f_out, " - [ON]");
	fclose(f_out);
	}

void GetKey(void)
	{
	key = ngetchx();
	clrscr();
	printf("KEY PRESS VALUE : %d", key);
	}